%global scl devtoolset-2
%{?scl:%scl_package}
Summary: Package that installs %scl
Name: %scl_name
Version: 2.1
Release: 3%{?dist}
BuildArch: noarch
License: GPLv2+
Group: Applications/File
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires: %{scl_prefix}toolchain %{scl_prefix}perftools
%{?scl:BuildRequires: scl-utils-build}
%{?scl:BuildRequires: iso-codes}

%description
This is the main package for %scl Software Collection.

%package runtime
Summary: Package that handles %scl Software Collection.
Group: Applications/File
Requires: scl-utils

%description runtime
Package shipping essential scripts to work with %scl Software Collection.

%package build
Summary: Package shipping basic build configuration
Group: Applications/File

%description build
Package shipping essential configuration macros to build %scl Software Collection.

%package toolchain
Summary: Package shipping basic toolchain applications
Group: Applications/File
Requires: %{scl_prefix}runtime
Requires: %{scl_prefix}gcc %{scl_prefix}gcc-c++ %{scl_prefix}gcc-gfortran
Requires: %{scl_prefix}binutils %{scl_prefix}gdb %{scl_prefix}strace
Requires: %{scl_prefix}dwz %{scl_prefix}elfutils %{scl_prefix}memstomp
%{?scl:BuildRequires: scl-utils-build}
%{?scl:BuildRequires: iso-codes}

%description toolchain
Package shipping basic toolchain applications (compiler, debugger, ...)

%package perftools
Summary: Package shipping performance tools
Group: Applications/File
Requires: %{scl_prefix}runtime
Requires: %{scl_prefix}oprofile %{scl_prefix}systemtap %{scl_prefix}valgrind
Requires: %{scl_prefix}dyninst
%{?scl:BuildRequires: scl-utils-build}
%{?scl:BuildRequires: iso-codes}

%description perftools
Package shipping performance tools (systemtap, oprofile)

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/%{_scl_scripts}/root
cat > %{buildroot}/%{_scl_scripts}/enable <<\EOF
export PATH=%{_bindir}${PATH:+:${PATH}}
export MANPATH=%{_mandir}:$MANPATH
export INFOPATH=%{_infodir}${INFOPATH:+:${INFOPATH}}
export PCP_DIR=%{_scl_root}
# Some perl Ext::MakeMaker versions install things under /usr/lib/perl5
# even though the system otherwise would go to /usr/lib64/perl5.
export PERL5LIB=%{_scl_root}/%{perl_vendorarch}:%{_scl_root}/usr/lib/perl5:%{_scl_root}/%{perl_vendorlib}${PERL5LIB:+:${PERL5LIB}}
# bz847911 workaround:
# we need to evaluate rpm's installed run-time % { _libdir }, not rpmbuild time
# or else /etc/ld.so.conf.d files?
rpmlibdir=`rpm --eval "%%{_libdir}"`
# bz1017604: On 64-bit hosts, we should include also the 32-bit library path.
if [ "$rpmlibdir" != "${rpmlibdir/lib64/}" ]; then
  rpmlibdir32=":%{_scl_root}${rpmlibdir/lib64/lib}"
fi
export LD_LIBRARY_PATH=%{_scl_root}$rpmlibdir$rpmlibdir32${LD_LIBRARY_PATH:+:${LD_LIBRARY_PATH}}
# duplicate python site.py logic for sitepackages
pythonvers=`python -c 'import sys; print sys.version[:3]'`
export PYTHONPATH=%{_prefix}/lib64/python$pythonvers/site-packages:%{_prefix}/lib/python$pythonvers/site-packages${PYTHONPATH:+:${PYTHONPATH}}
EOF
mkdir -p %{buildroot}/%{_scl_root}/usr/bin
cat > %{buildroot}/%{_scl_root}/usr/bin/sudo <<\EOF
#! /bin/sh
# TODO: parse & pass-through sudo options from $@
sudo_options="-E"

for arg in "$@"
do
   case "$arg" in
    *\'*)
      arg=`echo "$arg" | sed "s/'/'\\\\\\\\''/g"` ;;
   esac
   cmd_options="$cmd_options '$arg'" 
done

exec /usr/bin/sudo $sudo_options LD_LIBRARY_PATH=$LD_LIBRARY_PATH PATH=$PATH scl enable devtoolset-2 "$cmd_options"
EOF
chmod 0755 %{buildroot}/%{_scl_root}/usr/bin/sudo
%scl_install
find %{buildroot}%{_scl_root} -type d | xargs chmod 755
mkdir -p %{buildroot}%{_sysconfdir}/alternatives
mkdir -p %{buildroot}%{_scl_root}/var/lib/alternatives
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_prefix}/lib
mkdir -p %{buildroot}%{_prefix}/lib64
mkdir -p %{buildroot}%{_libexecdir}
mkdir -p %{buildroot}%{_mandir}
mkdir -p %{buildroot}%{_infodir}
mkdir -p %{buildroot}%{_includedir}
mkdir -p %{buildroot}%{_datadir}/locale
mkdir -p %{buildroot}%{_docdir}

%files

%files runtime
%defattr(-,root,root,-)
%scl_files
%{_scl_root}/usr/bin/sudo

%files build
%{_root_sysconfdir}/rpm/macros.%{scl}-config

%files toolchain

%files perftools

%changelog
* Mon Oct 14 2013 Marek Polacek <polacek@redhat.com> 2.1-3
- bz1017604: add 32-bit library path to LD_LIBRARY_PATH

* Mon Oct 07 2013 Marek Polacek <polacek@redhat.com> 2.1-2
- bz1001046: propagate PATH variable to sudo.

* Thu Oct 03 2013 Marek Polacek <polacek@redhat.com> 2.1-1
- bump to 2.1 version

* Thu Aug 08 2013 Marek Polacek <polacek@redhat.com> 2.0-19
- bz978796: propagate LD_LIBRARY_PATH variable to sudo.  Patch by
  Miroslav Franc.

* Mon Apr 29 2013 Marek Polacek <polacek@redhat.com> 2.0-14
- bz957846: toolchain subpackage should require strace

* Wed Apr 24 2013 Frank Ch. Eigler <fche@redhat.com> 2.0-13
- bz920963; bring in sudo wrapper fixes from devtoolset-1.1-12 (bz849452)

* Mon Mar 25 2013 Marek Polacek <polacek@redhat.com> 2.0-12
- require also memstomp and dyninst

* Wed Mar 20 2013 Marek Polacek <polacek@redhat.com> 2.0-11
- devtoolset-2-{perftools,toolchain}: require devtoolset-2-runtime

* Tue Mar 19 2013 Matt Newsome <mnewsome@redhat.com> 2.0-10
- moved valgrind from devtoolset-2-toolchain to -perftools subpackage
- bump version; sync NVR with devtoolset-2 meta package for rhel6

* Thu Mar 14 2013 Marek Polacek <polacek@redhat.com> 2.0-4
- new subpackages: devtoolset-2-{toolchain,perftools}

* Fri Feb 22 2013 Marek Polacek <polacek@redhat.com> 2.0-3
- bz914732: remove dependency on pcp{,-scl-initscripts}

* Fri Jan 25 2013 Marek Polacek <polacek@redhat.com> 2.0-2
- Just bump the version.

* Wed Oct 31 2012 Marek Polacek <polacek@redhat.com> 2.0-1
- Initial package
